﻿using System;
using UnityEngine;
using Object = UnityEngine.Object;

namespace CloneGames.ObjectPool
{
    public static class Extensions
    {
        public static T Spawn<T>(this T original) where T : Object => ObjectPoolService.Instance.Spawn(original);
        
        public static T Spawn<T>(this T original, Transform parent) where T : Object => ObjectPoolService.Instance.Spawn(original, parent);
        
        public static T Spawn<T>(this T original, Vector3 position, Quaternion rotation) where T : Object => ObjectPoolService.Instance.Spawn(original, position, rotation);
        
        public static T Spawn<T>(this T original, Vector3 position, Quaternion rotation, Transform parent) where T : Object => ObjectPoolService.Instance.Spawn(original, position, rotation, parent);

        public static void Recycle(this Object instance) => ObjectPoolService.Instance.Recycle(instance);

        public static void ClearPool<T>(this T original) where T : Object => ObjectPoolService.Instance.ClearPool<T>(original);
    }
}